libzypp: zypp::sat Namespace Reference

libzypp 17.36.6

Namespaces | Classes | Typedefs | Functions | Variables
zypp::sat Namespace Reference

## Namespaces
namespace | detail
namespace | solvitermixin_detail

## Classes
class | AllPTFs
| Container of packages providing `ptf()` More...
class | ArrayAttr
| LookupAttr::TransformIterator based container to retrieve list attributes. More...
struct | asSolvable
| To Solvable transform functor. More...
class | FileConflicts
| Libsolv queue representing file conflicts. More...
class | LocaleSupport
| Convenience methods to manage support for a specific Locale. More...
class | LookupAttr
| Lightweight attribute value lookup. More...
class | LookupRepoAttr
| Lightweight repository attribute value lookup. More...
class | Map
| Libsolv (bit)Map wrapper. More...
class | Pool
| Global sat-pool. More...
class | Queue
| Libsolv Id queue wrapper. More...
class | Solvable
| A Solvable object within the sat Pool. More...
class | SolvableSet
| Solvable set wrapper to allow adding additional convenience iterators. More...
class | SolvableType
| Base class for creating Solvable based types. More...
class | SolvAttr
| Solvable attribute keys. More...
class | SolvIterMixin
| Base class providing common iterator types based on a Solvable iterator. More...
class | Transaction
| Libsolv transaction wrapper. More...
class | WhatObsoletes
| Container of installed Solvable which would be obsoleted by the Solvable passed to the ctor. More...
class | WhatProvides
| Container of Solvable providing a Capability (read only). More...

## Typedefs
using | SolvableQueue = Queue
| Queue with Solvable ids.
using | StringQueue = Queue
| Queue with String ids.

## Functions
std::ostream & | operator<< (std::ostream &str, const FileConflicts &obj)
std::ostream & | operator<< (std::ostream &str, const FileConflicts::Conflict &obj)
std::ostream & | dumpAsXmlOn (std::ostream &str, const FileConflicts &obj)
std::ostream & | dumpAsXmlOn (std::ostream &str, const FileConflicts::Conflict &obj)
std::ostream & | operator<< (std::ostream &str, const LocaleSupport &obj)
std::ostream & | dumpOn (std::ostream &str, const LocaleSupport &obj)
std::ostream & | operator<< (std::ostream &str, const LookupAttr &obj)
std::ostream & | dumpOn (std::ostream &str, const LookupAttr &obj)
std::ostream & | operator<< (std::ostream &str, const LookupAttr::iterator &obj)
template<class TResult, class TAttr>
std::ostream & | operator<< (std::ostream &str, const ArrayAttr< TResult, TAttr > &obj)
bool | operator== (const Map &lhs, const Map &rhs)
std::ostream & | operator<< (std::ostream &str, const Pool &obj)
void | updateSolvFileIndex (const Pathname &solvfile_r)
| Create solv file content digest for zypper bash completion.
std::ostream & | operator<< (std::ostream &str, const Queue &obj)
std::ostream & | dumpOn (std::ostream &str, const Queue &obj)
bool | operator== (const Queue &lhs, const Queue &rhs)
std::ostream & | operator<< (std::ostream &str, const Solvable &obj)
std::ostream & | dumpOn (std::ostream &str, const Solvable &obj)
std::ostream & | dumpAsXmlOn (std::ostream &str, const Solvable &obj)
std::ostream & | operator<< (std::ostream &str, const SolvableSet &obj)
std::ostream & | operator<< (std::ostream &str, const SolvableSpec &obj)
| SolvableSpec ()
| ~SolvableSpec ()
| Dtor.
| SolvableSpec (const SolvableSpec &)=default
| SolvableSpec (SolvableSpec &&) noexcept=default
SolvableSpec & | operator= (const SolvableSpec &)=default
SolvableSpec & | operator= (SolvableSpec &&) noexcept=default
void | addIdent (IdString ident_r)
| Add all sat::Solvable with this ident_r.
void | addProvides (Capability provides_r)
| A all sat::Solvable matching this provides_r.
bool | addIdenticalInstalledToo () const
| Extend the provides set to include idential installed items as well.
void | addIdenticalInstalledToo (bool yesno_r)
void | parse (const C_Str &spec_r)
| Parse and add spec from a string (`IDENT` or provides:CAPABILITY`).
void | parseFrom (const InputStream &istr_r)
| Parse file istr_r and add its specs (one per line, #-comments).
template<class TIterator>
void | parseFrom (TIterator begin, TIterator end)
| Parse and add specs from iterator range.
void | splitParseFrom (const C_Str &multispec_r)
| Convenience using str::splitEscaped(", \t") to parse multiple specs from one line.
bool | contains (const sat::Solvable &solv_r) const
| Test whether solv_r matches the spec.
template<class Derived>
bool | contains (const SolvableType< Derived > &solv_r) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
bool | dirty () const
| Whether the cache is needed and dirty.
void | setDirty () const
| Explicitly flag the cache as dirty, so it will be rebuilt on the next request.
bool | empty () const
| Whether neither idents nor provides are set.
bool | containsIdent (const IdString &ident_r) const
| Whether ident_r has been added to the specs (mainly for parser tests).
bool | containsProvides (const Capability &provides_r) const
| Whether provides_r has been added to the sepcs (mainly for parser tests).
template<class Derived>
bool | operator== (const SolvableType< Derived > &lhs, const Solvable &rhs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<class Derived>
bool | operator== (const Solvable &lhs, const SolvableType< Derived > &rhs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<class Derived>
bool | operator!= (const SolvableType< Derived > &lhs, const Solvable &rhs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<class Derived>
bool | operator!= (const Solvable &lhs, const SolvableType< Derived > &rhs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<class Derived>
bool | operator< (const SolvableType< Derived > &lhs, const Solvable &rhs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<class Derived>
bool | operator< (const Solvable &lhs, const SolvableType< Derived > &rhs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<class Derived>
bool | identical (const SolvableType< Derived > &lhs, const Solvable &rhs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<class Derived>
bool | identical (const Solvable &lhs, const SolvableType< Derived > &rhs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<class Derived>
bool | sameNVRA (const SolvableType< Derived > &lhs, const Solvable &rhs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<class Derived>
bool | sameNVRA (const Solvable &lhs, const SolvableType< Derived > &rhs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<class Derived>
bool | compareByN (const SolvableType< Derived > &lhs, const Solvable &rhs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<class Derived>
bool | compareByN (const Solvable &lhs, const SolvableType< Derived > &rhs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<class Derived>
bool | compareByNVR (const SolvableType< Derived > &lhs, const Solvable &rhs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<class Derived>
bool | compareByNVR (const Solvable &lhs, const SolvableType< Derived > &rhs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<class Derived>
bool | compareByNVRA (const SolvableType< Derived > &lhs, const Solvable &rhs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<class Derived>
bool | compareByNVRA (const Solvable &lhs, const SolvableType< Derived > &rhs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
std::ostream & | operator<< (std::ostream &str, const Transaction &obj)
std::ostream & | dumpOn (std::ostream &str, const Transaction &obj)
bool | operator== (const Transaction &lhs, const Transaction &rhs)
std::ostream & | operator<< (std::ostream &str, const Transaction::Step &obj)
std::ostream & | operator<< (std::ostream &str, Transaction::StepType obj)
std::ostream & | operator<< (std::ostream &str, Transaction::StepStage obj)
| ZYPP_DECLARE_OPERATORS_FOR_FLAGS (Transaction::StepStages)
std::ostream & | operator<< (std::ostream &str, const WhatObsoletes &obj)
std::ostream & | operator<< (std::ostream &str, const WhatProvides &obj)
std::ostream & | operator<< (std::ostream &str, const FileConflicts &obj) ZYPP_API
| Stream output.
std::ostream & | dumpAsXmlOn (std::ostream &str, const FileConflicts &obj) ZYPP_API
| XML output.
bool | operator== (const FileConflicts &lhs, const FileConflicts &rhs)
bool | operator!= (const FileConflicts &lhs, const FileConflicts &rhs)
std::ostream & | operator<< (std::ostream &str, const LocaleSupport &obj)
| Stream output.
std::ostream & | dumpOn (std::ostream &str, const LocaleSupport &obj)
| More verbose stream output including dependencies.
bool | operator== (const LocaleSupport &lhs, const LocaleSupport &rhs)
bool | operator!= (const LocaleSupport &lhs, const LocaleSupport &rhs)
bool | operator< (const LocaleSupport &lhs, const LocaleSupport &rhs)
std::ostream & | operator<< (std::ostream &str, const LookupAttr &obj) ZYPP_API
| Stream output.
std::ostream & | dumpOn (std::ostream &str, const LookupAttr &obj) ZYPP_API
| Verbose stream output including the query result.
std::ostream & | operator<< (std::ostream &str, const Map &obj)
| Stream output.
bool | operator== (const Map &lhs, const Map &rhs) ZYPP_API
bool | operator!= (const Map &lhs, const Map &rhs)
std::ostream & | operator<< (std::ostream &str, const Pool &obj) ZYPP_API
| Stream output.
bool | operator== (const Pool &lhs, const Pool &rhs)
bool | operator!= (const Pool &lhs, const Pool &rhs)
std::ostream & | operator<< (std::ostream &str, const Queue &obj) ZYPP_API
| Stream output.
std::ostream & | dumpOn (std::ostream &str, const Queue &obj) ZYPP_API
| Stream output assuming a Solvable queue.
bool | operator== (const Queue &lhs, const Queue &rhs) ZYPP_API
bool | operator!= (const Queue &lhs, const Queue &rhs)
std::ostream & | operator<< (std::ostream &str, const Solvable &obj) ZYPP_API
| Stream output.
std::ostream & | dumpOn (std::ostream &str, const Solvable &obj) ZYPP_API
| More verbose stream output including dependencies.
std::ostream & | dumpAsXmlOn (std::ostream &str, const Solvable &obj) ZYPP_API
| XML output.
bool | operator== (const Solvable &lhs, const Solvable &rhs)
bool | operator!= (const Solvable &lhs, const Solvable &rhs)
bool | operator< (const Solvable &lhs, const Solvable &rhs)
template<class TRes>
bool | isKind (const Solvable &solvable_r)
| Test whether a Solvable is of a certain Kind.
bool | identical (const Solvable &lhs, const Solvable &rhs)
| Test for same content.
bool | sameNVRA (const Solvable &lhs, const Solvable &rhs)
| Test for same name version release and arch.
int | compareByN (const Solvable &lhs, const Solvable &rhs)
| Compare according to kind and name.
int | compareByNVR (const Solvable &lhs, const Solvable &rhs)
| Compare according to kind, name and edition.
int | compareByNVRA (const Solvable &lhs, const Solvable &rhs)
| Compare according to kind, name, edition and arch.
std::ostream & | operator<< (std::ostream &str, const SolvableSet &obj) ZYPP_API
| Stream output.
template<class Derived>
std::ostream & | operator<< (std::ostream &str, const SolvableType< Derived > &obj)
| Stream output.
template<class Derived>
std::ostream & | dumpOn (std::ostream &str, const SolvableType< Derived > &obj)
| More verbose stream output including dependencies.
template<class LDerived, class RDerived>
bool | operator== (const SolvableType< LDerived > &lhs, const SolvableType< RDerived > &rhs)
| Equal.
template<class LDerived, class RDerived>
bool | operator!= (const SolvableType< LDerived > &lhs, const SolvableType< RDerived > &rhs)
| NotEqual.
template<class LDerived, class RDerived>
bool | operator< (const SolvableType< LDerived > &lhs, const SolvableType< RDerived > &rhs)
| Less.
template<class TRes, class Derived>
bool | isKind (const SolvableType< Derived > &solvable_r)
| Test whether the Solvable is of a certain ResKind.
template<class LDerived, class RDerived>
bool | identical (const SolvableType< LDerived > &lhs, const SolvableType< RDerived > &rhs)
| Test for same content.
template<class LDerived, class RDerived>
bool | sameNVRA (const SolvableType< LDerived > &lhs, const SolvableType< RDerived > &rhs)
| Test for same name version release and arch.
template<class LDerived, class RDerived>
int | compareByN (const SolvableType< LDerived > &lhs, const SolvableType< RDerived > &rhs)
| Compare according to kind and name.
template<class LDerived, class RDerived>
int | compareByNVR (const SolvableType< LDerived > &lhs, const SolvableType< RDerived > &rhs)
| Compare according to kind, name and edition.
template<class LDerived, class RDerived>
int | compareByNVRA (const SolvableType< LDerived > &lhs, const SolvableType< RDerived > &rhs)
| Compare according to kind, name, edition and arch.
std::ostream & | operator<< (std::ostream &str, const Transaction &obj) ZYPP_API
| Stream output.
std::ostream & | dumpOn (std::ostream &str, const Transaction &obj) ZYPP_API
| Verbose stream output.
bool | operator== (const Transaction &lhs, const Transaction &rhs) ZYPP_API
bool | operator!= (const Transaction &lhs, const Transaction &rhs)
std::ostream & | operator<< (std::ostream &str, const WhatObsoletes &obj)
| Stream output.
std::ostream & | operator<< (std::ostream &str, const WhatProvides &obj)
| Stream output.
static const SolvableIdType | noSolvableId (0)
| Id to denote Solvable::noSolvable.
Helpers and forward declarations from LookupAttrTools.h
template<>
std::string | LookupAttr::iterator::asType< std::string > () const

## Variables
RWCOW_pointer< Impl > | _pimpl
| Implementation class.
bool | obsoleteUsesProvides = false

## Typedef Documentation

## ◆ SolvableQueue

using zypp::sat::SolvableQueue = Queue

Queue with Solvable ids.

Definition at line 27 of file Queue.h.

## ◆ StringQueue

using zypp::sat::StringQueue = Queue

Queue with String ids.

Definition at line 28 of file Queue.h.

## Function Documentation

## ◆ operator<<() [1/29]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | const FileConflicts & | obj )
| related

Definition at line 109 of file FileConflicts.cc.

## ◆ operator<<() [2/29]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | const FileConflicts::Conflict & | obj )
| related

Definition at line 112 of file FileConflicts.cc.

## ◆ dumpAsXmlOn() [1/5]

std::ostream & zypp::sat::dumpAsXmlOn | ( | std::ostream & | str,
|  | const FileConflicts & | obj )
| related

Definition at line 132 of file FileConflicts.cc.

## ◆ dumpAsXmlOn() [2/5]

std::ostream & zypp::sat::dumpAsXmlOn | ( | std::ostream & | str,
|  | const FileConflicts::Conflict & | obj )
| related

Definition at line 156 of file FileConflicts.cc.

## ◆ operator<<() [3/29]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | const LocaleSupport & | obj )
| related

Definition at line 31 of file LocaleSupport.cc.

## ◆ dumpOn() [1/11]

std::ostream & zypp::sat::dumpOn | ( | std::ostream & | str,
|  | const LocaleSupport & | obj )
| related

Definition at line 41 of file LocaleSupport.cc.

## ◆ operator<<() [4/29]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | const LookupAttr & | obj )
| related

Definition at line 256 of file LookupAttr.cc.

## ◆ dumpOn() [2/11]

std::ostream & zypp::sat::dumpOn | ( | std::ostream & | str,
|  | const LookupAttr & | obj )
| related

Definition at line 273 of file LookupAttr.cc.

## ◆ operator<<() [5/29]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | const LookupAttr::iterator & | obj )
| related

Definition at line 782 of file LookupAttr.cc.

## ◆ LookupAttr::iterator::asType< std::string >()

template<>

std::string zypp::sat::LookupAttr::iterator::asType< std::string > | ( |  | ) | const
| inline

Definition at line 594 of file LookupAttr.h.

## ◆ operator<<() [6/29]

template<class TResult, class TAttr>

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | const ArrayAttr< TResult, TAttr > & | obj )
| related

## ◆ operator==() [1/13]

bool zypp::sat::operator== | ( | const Map & | lhs,
|  | const Map & | rhs )
| related

Definition at line 125 of file Map.cc.

## ◆ operator<<() [7/29]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | const Pool & | obj )
| related

Definition at line 274 of file Pool.cc.

## ◆ updateSolvFileIndex()

void zypp::sat::updateSolvFileIndex | ( | const Pathname & | solvfile_r | ) |

Create solv file content digest for zypper bash completion.

Definition at line 286 of file Pool.cc.

## ◆ operator<<() [8/29]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | const Queue & | obj )
| related

Definition at line 121 of file Queue.cc.

## ◆ dumpOn() [3/11]

std::ostream & zypp::sat::dumpOn | ( | std::ostream & | str,
|  | const Queue & | obj )
| related

Definition at line 124 of file Queue.cc.

## ◆ operator==() [2/13]

bool zypp::sat::operator== | ( | const Queue & | lhs,
|  | const Queue & | rhs )
| related

Definition at line 136 of file Queue.cc.

## ◆ operator<<() [9/29]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | const Solvable & | obj )
| related

Definition at line 794 of file Solvable.cc.

## ◆ dumpOn() [4/11]

std::ostream & zypp::sat::dumpOn | ( | std::ostream & | str,
|  | const Solvable & | obj )
| related

Definition at line 805 of file Solvable.cc.

## ◆ dumpAsXmlOn() [3/5]

std::ostream & zypp::sat::dumpAsXmlOn | ( | std::ostream & | str,
|  | const Solvable & | obj )
| related

Definition at line 825 of file Solvable.cc.

## ◆ operator<<() [10/29]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | const SolvableSet & | obj )
| related

Definition at line 31 of file SolvableSet.cc.

## ◆ operator<<() [11/29]

std::ostream & operator<< | ( | std::ostream & | str,
|  | const SolvableSpec & | obj )

Definition at line 201 of file SolvableSpec.cc.

## ◆ SolvableSpec() [1/3]

zypp::sat::SolvableSpec | ( |  | ) |

        \class SolvableSpec
        \brief Define a set of \ref Solvables by ident and provides.

        Able to keep the definition of solvable sets like in 'needreboot'
        or 'multiversion'. The associated file parser allows reading
        stored definitions (one `IDENT` or provides:CAPABILITY` per line;

/ empty lines and lines starting with '#' are ignored). / / The use of provides requires re-computation of the solvable set, / whenever the solvable pool changes. This computation via WhatProvides / is expensive, that's why a built in cache is also offered. / /

Note
  contains does not match srcpackage: per default. ///////////////////////////////////////////////////////////////// class SolvableSpec { public: /** Default ctor

## ◆ ~SolvableSpec()

zypp::sat::~SolvableSpec | ( |  | ) |

Dtor.

## ◆ SolvableSpec() [2/3]

zypp::sat::SolvableSpec | ( | const SolvableSpec & |  | ) |
| default

## ◆ SolvableSpec() [3/3]

zypp::sat::SolvableSpec | ( | SolvableSpec && |  | ) |
| defaultnoexcept

## ◆ operator=() [1/2]

SolvableSpec & zypp::sat::operator= | ( | const SolvableSpec & |  | ) |
| default

## ◆ operator=() [2/2]

SolvableSpec & zypp::sat::operator= | ( | SolvableSpec && |  | ) |
| defaultnoexcept

## ◆ addIdent()

void zypp::sat::addIdent | ( | IdString | ident_r | ) |

Add all sat::Solvable with this ident_r.

## ◆ addProvides()

void zypp::sat::addProvides | ( | Capability | provides_r | ) |

A all sat::Solvable matching this provides_r.

## ◆ addIdenticalInstalledToo() [1/2]

bool zypp::sat::addIdenticalInstalledToo | ( |  | ) | const

Extend the provides set to include idential installed items as well.

Hack for retracted packages, where the indicator provides is injected into the available items, but is not present in the installed items.

## ◆ addIdenticalInstalledToo() [2/2]

void zypp::sat::addIdenticalInstalledToo | ( | bool | yesno_r | ) |

## ◆ parse()

void zypp::sat::parse | ( | const C_Str & | spec_r | ) |

Parse and add spec from a string (`IDENT` or provides:CAPABILITY`).

*‍/

## ◆ parseFrom() [1/2]

void zypp::sat::parseFrom | ( | const InputStream & | istr_r | ) |

Parse file istr_r and add its specs (one per line, #-comments).

## ◆ parseFrom() [2/2]

template<class TIterator>

void zypp::sat::parseFrom | ( | TIterator | begin,
|  | TIterator | end )

Parse and add specs from iterator range.

Definition at line 81 of file SolvableSpec.h.

## ◆ splitParseFrom()

void zypp::sat::splitParseFrom | ( | const C_Str & | multispec_r | ) |

Convenience using str::splitEscaped(", \t") to parse multiple specs from one line.

## ◆ contains() [1/2]

bool zypp::sat::contains | ( | const sat::Solvable & | solv_r | ) | const

Test whether solv_r matches the spec.

(Re-)builds the WhatProvides cache on demand.

Note
  Does not match srcpackage: per default.

## ◆ contains() [2/2]

template<class Derived>

bool zypp::sat::contains | ( | const SolvableType< Derived > & | solv_r | ) | const

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 96 of file SolvableSpec.h.

## ◆ dirty()

bool zypp::sat::dirty | ( |  | ) | const

Whether the cache is needed and dirty.

## ◆ setDirty()

void zypp::sat::setDirty | ( |  | ) | const

Explicitly flag the cache as dirty, so it will be rebuilt on the next request.

To be called if the ResPool content has changed. Intentionally `const` as this does not change the set of spects (though the set of matches might change).

Note
  This has no effect if no cache is needed (i.e. no provides: are used).

## ◆ empty()

bool zypp::sat::empty | ( |  | ) | const

Whether neither idents nor provides are set.

## ◆ containsIdent()

bool zypp::sat::containsIdent | ( | const IdString & | ident_r | ) | const

Whether ident_r has been added to the specs (mainly for parser tests).

## ◆ containsProvides()

bool zypp::sat::containsProvides | ( | const Capability & | provides_r | ) | const

Whether provides_r has been added to the sepcs (mainly for parser tests).

## ◆ operator==() [3/13]

template<class Derived>

bool zypp::sat::operator== | ( | const SolvableType< Derived > & | lhs,
|  | const Solvable & | rhs )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 188 of file SolvableType.h.

## ◆ operator==() [4/13]

template<class Derived>

bool zypp::sat::operator== | ( | const Solvable & | lhs,
|  | const SolvableType< Derived > & | rhs )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 192 of file SolvableType.h.

## ◆ operator!=() [1/10]

template<class Derived>

bool zypp::sat::operator!= | ( | const SolvableType< Derived > & | lhs,
|  | const Solvable & | rhs )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 201 of file SolvableType.h.

## ◆ operator!=() [2/10]

template<class Derived>

bool zypp::sat::operator!= | ( | const Solvable & | lhs,
|  | const SolvableType< Derived > & | rhs )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 205 of file SolvableType.h.

## ◆ operator<() [1/5]

template<class Derived>

bool zypp::sat::operator< | ( | const SolvableType< Derived > & | lhs,
|  | const Solvable & | rhs )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 214 of file SolvableType.h.

## ◆ operator<() [2/5]

template<class Derived>

bool zypp::sat::operator< | ( | const Solvable & | lhs,
|  | const SolvableType< Derived > & | rhs )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 218 of file SolvableType.h.

## ◆ identical() [1/4]

template<class Derived>

bool zypp::sat::identical | ( | const SolvableType< Derived > & | lhs,
|  | const Solvable & | rhs )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 232 of file SolvableType.h.

## ◆ identical() [2/4]

template<class Derived>

bool zypp::sat::identical | ( | const Solvable & | lhs,
|  | const SolvableType< Derived > & | rhs )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 236 of file SolvableType.h.

## ◆ sameNVRA() [1/4]

template<class Derived>

bool zypp::sat::sameNVRA | ( | const SolvableType< Derived > & | lhs,
|  | const Solvable & | rhs )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 245 of file SolvableType.h.

## ◆ sameNVRA() [2/4]

template<class Derived>

bool zypp::sat::sameNVRA | ( | const Solvable & | lhs,
|  | const SolvableType< Derived > & | rhs )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 249 of file SolvableType.h.

## ◆ compareByN() [1/4]

template<class Derived>

bool zypp::sat::compareByN | ( | const SolvableType< Derived > & | lhs,
|  | const Solvable & | rhs )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 259 of file SolvableType.h.

## ◆ compareByN() [2/4]

template<class Derived>

bool zypp::sat::compareByN | ( | const Solvable & | lhs,
|  | const SolvableType< Derived > & | rhs )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 263 of file SolvableType.h.

## ◆ compareByNVR() [1/4]

template<class Derived>

bool zypp::sat::compareByNVR | ( | const SolvableType< Derived > & | lhs,
|  | const Solvable & | rhs )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 273 of file SolvableType.h.

## ◆ compareByNVR() [2/4]

template<class Derived>

bool zypp::sat::compareByNVR | ( | const Solvable & | lhs,
|  | const SolvableType< Derived > & | rhs )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 277 of file SolvableType.h.

## ◆ compareByNVRA() [1/4]

template<class Derived>

bool zypp::sat::compareByNVRA | ( | const SolvableType< Derived > & | lhs,
|  | const Solvable & | rhs )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 286 of file SolvableType.h.

## ◆ compareByNVRA() [2/4]

template<class Derived>

bool zypp::sat::compareByNVRA | ( | const Solvable & | lhs,
|  | const SolvableType< Derived > & | rhs )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 290 of file SolvableType.h.

## ◆ operator<<() [12/29]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | const Transaction & | obj )
| related

Definition at line 366 of file Transaction.cc.

## ◆ dumpOn() [5/11]

std::ostream & zypp::sat::dumpOn | ( | std::ostream & | str,
|  | const Transaction & | obj )
| related

Definition at line 369 of file Transaction.cc.

## ◆ operator==() [5/13]

bool zypp::sat::operator== | ( | const Transaction & | lhs,
|  | const Transaction & | rhs )
| related

Definition at line 378 of file Transaction.cc.

## ◆ operator<<() [13/29]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | const Transaction::Step & | obj )
| related

Definition at line 408 of file Transaction.cc.

## ◆ operator<<() [14/29]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | Transaction::StepType | obj )

Definition at line 418 of file Transaction.cc.

## ◆ operator<<() [15/29]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | Transaction::StepStage | obj )

Definition at line 432 of file Transaction.cc.

## ◆ ZYPP_DECLARE_OPERATORS_FOR_FLAGS()

zypp::sat::ZYPP_DECLARE_OPERATORS_FOR_FLAGS | ( | Transaction::StepStages |  | ) |

## ◆ operator<<() [16/29]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | const WhatObsoletes & | obj )
| related

Definition at line 166 of file WhatObsoletes.cc.

## ◆ operator<<() [17/29]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | const WhatProvides & | obj )
| related

Definition at line 162 of file WhatProvides.cc.

## ◆ noSolvableId()

static const SolvableIdType zypp::sat::detail::noSolvableId | ( | 0 |  | ) |
| static

Id to denote Solvable::noSolvable.

## Variable Documentation

## ◆ _pimpl

RWCOW_pointer<Impl> zypp::sat::_pimpl
| private

Implementation class.

Pointer to implementation.

Definition at line 122 of file SolvableSpec.h.

## ◆ obsoleteUsesProvides

bool zypp::sat::obsoleteUsesProvides = false

Definition at line 34 of file WhatObsoletes.cc.